/// <reference types="react" />
export declare type FormFieldValue = string;
export declare type FormsContextT = {
    formsById: {
        [id: string]: {
            fieldsByName: {
                [name: string]: FormFieldValue;
            };
        };
    };
    _mountForm(id: string): void;
    _getFormValues<V extends {
        [name: string]: FormFieldValue;
    } = {
        [name: string]: FormFieldValue;
    }>(formId: string): V | null;
    _getFormFieldValue<V extends FormFieldValue = FormFieldValue>(formId: string, fieldName: string): V | null;
    _setFormFieldValue(formId: string, fieldName: string, fieldValue: FormFieldValue): void;
    _unmountForm(id: string): void;
};
export declare const FormsContext: import("react").Context<FormsContextT>;
