"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormsProvider = void 0;
var react_1 = __importStar(require("react"));
var FormsContext_1 = require("./FormsContext");
exports.FormsProvider = function (_a) {
    var children = _a.children;
    var _b = react_1.useState({}), formsById = _b[0], setFormsById = _b[1];
    var _mountForm = react_1.useCallback(function (id) {
        setFormsById(function (prev) {
            var _a;
            return (__assign(__assign({}, prev), (_a = {}, _a[id] = {
                fieldsByName: {},
            }, _a)));
        });
    }, [setFormsById]);
    var _getFormValues = react_1.useCallback(function (formId) {
        return (formsById === null || formsById === void 0 ? void 0 : formsById[formId].fieldsByName) || null;
    }, [formsById]);
    var _getFormFieldValue = react_1.useCallback(function (formId, fieldName) {
        var _a, _b;
        return ((_b = (_a = formsById === null || formsById === void 0 ? void 0 : formsById[formId]) === null || _a === void 0 ? void 0 : _a.fieldsByName) === null || _b === void 0 ? void 0 : _b[fieldName]) || null;
    }, [formsById]);
    var _setFormFieldValue = react_1.useCallback(function (formId, fieldName, fieldValue) {
        setFormsById(function (prev) {
            var _a, _b;
            var _c;
            return (__assign(__assign({}, (prev || {})), (_a = {}, _a[formId] = __assign(__assign({}, ((prev === null || prev === void 0 ? void 0 : prev[formId]) || {})), { fieldsByName: __assign(__assign({}, (((_c = prev === null || prev === void 0 ? void 0 : prev[formId]) === null || _c === void 0 ? void 0 : _c.fieldsByName) || {})), (_b = {}, _b[fieldName] = fieldValue, _b)) }), _a)));
        });
    }, [setFormsById]);
    var _unmountForm = react_1.useCallback(function (id) {
        setFormsById(function (prev) { return (__assign({}, Object.entries(prev)
            .filter(function (_a) {
            var formId = _a[0];
            return formId !== id;
        })
            .reduce(function (acc, _a) {
            var _b;
            var formId = _a[0], form = _a[1];
            acc = __assign(__assign({}, acc), (_b = {}, _b[formId] = form, _b));
            return acc;
        }, {}))); });
    }, [setFormsById]);
    var ctxValue = react_1.useMemo(function () { return ({
        _mountForm: _mountForm,
        _getFormValues: _getFormValues,
        _getFormFieldValue: _getFormFieldValue,
        _setFormFieldValue: _setFormFieldValue,
        _unmountForm: _unmountForm,
        formsById: formsById,
    }); }, [
        _mountForm,
        _getFormValues,
        _getFormFieldValue,
        _setFormFieldValue,
        _unmountForm,
        formsById,
    ]);
    return (react_1.default.createElement(FormsContext_1.FormsContext.Provider, { value: ctxValue }, children));
};
