import { SyntheticEvent } from "react";
import { NativeSyntheticEvent, ReturnKeyTypeOptions, TextInput, TextInputChangeEventData, TextInputFocusEventData } from "react-native";
import { FormFieldValue } from "./FormsContext";
declare type FormValues = {
    [name: string]: FormFieldValue;
};
declare type UseFormAPI<FV extends FormValues = FormValues, FN extends keyof FV = keyof FV> = {
    registerField<F extends FN = FN>(fieldName: F, opts?: {
        nextField?: Exclude<keyof FV, F>;
        returnKeyType?: ReturnKeyTypeOptions;
        returnSubmitsForm?: boolean;
    }): {
        onBlur: (e: NativeSyntheticEvent<TextInputFocusEventData>) => void;
        onChange: (e: NativeSyntheticEvent<TextInputChangeEventData>) => void;
        onSubmitEditing?: () => void;
        ref: (fieldRef: TextInput | null) => void;
        returnKeyType?: ReturnKeyTypeOptions;
        value?: FormFieldValue;
    };
    handleSubmit(wrappedFn: (ev: null | SyntheticEvent<any, Event>, formValues: FV) => void): () => void;
};
export declare function useForm<FV extends FormValues = FormValues, FN extends keyof FV = keyof FV>(formId: string, opts?: {
    initialValues?: Partial<FV>;
}): UseFormAPI<FV, FN>;
export {};
