"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useForm = void 0;
var react_1 = require("react");
var FormsContext_1 = require("./FormsContext");
function useForm(formId, opts) {
    var handleSubmitFunctionRef = react_1.useRef(null);
    var fieldsRefsRef = react_1.useRef({});
    var _a = react_1.useContext(FormsContext_1.FormsContext), _getFormValues = _a._getFormValues, _getFormFieldValue = _a._getFormFieldValue, _setFormFieldValue = _a._setFormFieldValue;
    var registerField = react_1.useCallback(function (fieldName, fieldOpts) {
        return {
            onChange: function (ev) {
                var _a;
                ev.persist();
                if (((_a = ev === null || ev === void 0 ? void 0 : ev.nativeEvent) === null || _a === void 0 ? void 0 : _a.text) == null)
                    return undefined;
                _setFormFieldValue(formId, fieldName, ev.nativeEvent.text);
            },
            onBlur: function (_ev) {
                return void 0;
            },
            onSubmitEditing: (fieldOpts === null || fieldOpts === void 0 ? void 0 : fieldOpts.nextField) != null
                ? function () {
                    var _a;
                    var ref = Object.entries(fieldsRefsRef.current).find(function (_a) {
                        var fName = _a[0];
                        return fName === fieldOpts.nextField;
                    });
                    if ((ref === null || ref === void 0 ? void 0 : ref[1]) != null) {
                        var inputRef = ref[1];
                        if (inputRef.isFocused() === false &&
                            ((_a = inputRef === null || inputRef === void 0 ? void 0 : inputRef.props) === null || _a === void 0 ? void 0 : _a.editable) !== false) {
                            inputRef.focus();
                        }
                    }
                }
                : (fieldOpts === null || fieldOpts === void 0 ? void 0 : fieldOpts.returnSubmitsForm) &&
                    handleSubmitFunctionRef.current != null
                    ? function () {
                        var _a;
                        var formValues = _getFormValues(formId);
                        (_a = handleSubmitFunctionRef === null || handleSubmitFunctionRef === void 0 ? void 0 : handleSubmitFunctionRef.current) === null || _a === void 0 ? void 0 : _a.call(handleSubmitFunctionRef, null, formValues);
                    }
                    : undefined,
            ref: function (instance) {
                var _a;
                if (instance) {
                    fieldsRefsRef.current = __assign(__assign({}, ((fieldsRefsRef === null || fieldsRefsRef === void 0 ? void 0 : fieldsRefsRef.current) || {})), (_a = {}, _a[fieldName] = instance, _a));
                }
            },
            returnKeyType: (fieldOpts === null || fieldOpts === void 0 ? void 0 : fieldOpts.nextField) != null
                ? "next"
                : (fieldOpts === null || fieldOpts === void 0 ? void 0 : fieldOpts.returnKeyType) || undefined,
            value: _getFormFieldValue(formId, fieldName) || undefined,
        };
    }, [_getFormFieldValue, _setFormFieldValue, formId]);
    var handleSubmit = react_1.useCallback(function (wrappedFn) {
        handleSubmitFunctionRef.current = wrappedFn;
        return function (ev) {
            var formValues = _getFormValues(formId);
            wrappedFn(ev, formValues);
            return undefined;
        };
    }, [_getFormValues, formId]);
    react_1.useEffect(function () {
        if ((opts === null || opts === void 0 ? void 0 : opts.initialValues) != null) {
            Object.entries(opts.initialValues).forEach(function (_a) {
                var k = _a[0], v = _a[1];
                _setFormFieldValue(formId, k, v);
            });
        }
    }, []);
    return react_1.useMemo(function () { return ({
        registerField: registerField,
        handleSubmit: handleSubmit,
    }); }, [registerField, handleSubmit]);
}
exports.useForm = useForm;
