import React, { FC, useContext, useEffect } from "react";

import { FormsContext } from "./FormsContext";

type FormProps = {
  id: string;
};

export const Form: FC<FormProps> = ({ children, id }) => {
  const { formsById, _mountForm, _unmountForm } = useContext(FormsContext);

  // an effect to insert/remove a form into the FormsContext.formsById hash-map
  useEffect(() => {
    if (id in formsById === false) {
      _mountForm(id);
    }

    return () => {
      _unmountForm(id);
    };
  }, []);

  return <>{children}</>;
};
